-- true/false defn
FALSE = 0
TRUE = 1

-- condition return values
CONDITION_NOT_YET_MET = 0
CONDITION_SUCCEEDED = 1
CONDITION_FAILED = 2

-- Message types
MT_INFO = 0   -- large centre screen pop up
MT_ALERT = 1  -- top right alert message

MSG_TOP = 1
MSG_VCENTRE = 2
MSG_BOTTOM = 4
MSG_LEFT = 8
MSG_CENTRE = 16
MSG_RIGHT = 32

MSG_SMALL = 0
MSG_REG = 1
MSG_LRG = 2

MPH = 2.23693629
KMH = 3.6

gSpeedUnits = MPH
gVehicleNum = ""

gStopLocation = ""
gStopMessageEvent = ""
gStopChangeEvent = ""
gStopPlayerServiceName = "2Y69 SRA - CLJ"

StopFlag = 0
SpeedFlag = 0

gStartLocation = ""
gStartEvent = ""

gDetailed = "Yes"

CLJ = "d" -- Clapham Junction
RMD = "l" -- Richmond
SRA = 'm' -- Stratford
WJH = "q" -- Willesden Junction
NIS = "y" -- Not in service

function OnEvent(event)
	return _G["OnEvent" .. event]();
end

function TestCondition(condition)
	return _G["TestCondition" .. condition]();
end

function DisplayRecordedMessage( messageName )
	SysCall("RegisterRecordedMessage", "StartDisplay" .. messageName, "StopDisplay" .. messageName, 1);
end

function StartDisplayIntroText1()
	SysCall ( "ScenarioManager:ShowInfoMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "intro1.html", 13, MSG_VCENTRE + MSG_CENTRE, MSG_SMALL, FALSE );
end

function StopDisplayIntroText1()
end

function StartDisplayIntroText2()
	SysCall ( "ScenarioManager:ShowInfoMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "intro2.html", 0, MSG_VCENTRE + MSG_CENTRE, MSG_SMALL, TRUE );
end

function StopDisplayIntroText2()
end

function StartDisplayChangeoverDown()
	SysCall ( "ScenarioManager:ShowInfoMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "changeover1.html", 20, MSG_VCENTRE + MSG_CENTRE, MSG_REG, FALSE );
end

function StopDisplayChangeoverDown()
end

function StartDisplayChangeoverUp()
	SysCall ( "ScenarioManager:ShowInfoMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "changeover2.html", 0, MSG_VCENTRE + MSG_CENTRE, MSG_REG, TRUE );
end

function StopDisplayChangeoverUp()
end

function StartDisplayChangeCab_CLJ()
	SysCall ( "ScenarioManager:ShowInfoMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "changecab1.html", 0, MSG_VCENTRE + MSG_CENTRE, MSG_SMALL, FALSE );
end

function StopDisplayChangeCab_CLJ()
end

function StartDisplayChangeCab_XKG()
	SysCall ( "ScenarioManager:ShowInfoMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "changecab2.html", 0, MSG_VCENTRE + MSG_CENTRE, MSG_SMALL, FALSE );
end

function StopDisplayChangeCab_XKG()
end

function StartDisplayDepartCLJ()
	SysCall ( "ScenarioManager:ShowInfoMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "departure1.html", 0, MSG_VCENTRE + MSG_CENTRE, MSG_SMALL, FALSE );
end

function StopDisplayDepartCLJ()
end

function StartDisplayDepartWJH()
	SysCall ( "ScenarioManager:ShowInfoMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "departure2.html", 0, MSG_VCENTRE + MSG_CENTRE, MSG_SMALL, TRUE );
end

function StopDisplayDepartWJH()
end

function StartDisplayGuard()
	SysCall ( "ScenarioManager:ShowInfoMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "guard.html", 0, MSG_VCENTRE + MSG_CENTRE, MSG_SMALL, FALSE );
end

function StopDisplayGuard()
end

function StartDisplaySignaller()
	SysCall ( "ScenarioManager:ShowInfoMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "signaller.html", 0, MSG_VCENTRE + MSG_CENTRE, MSG_SMALL, FALSE );
end

function StopDisplaySignaller()
end

function DeferredEvent ( event, time )
	SysCall("ScenarioManager:TriggerDeferredEvent", event, time);
end

function PlayCamera(camera)
	SysCall ( "CameraManager:ActivateCamera", camera, 0 );
end

function LockControls()
	SysCall ( "ScenarioManager:LockControls");
end

function UnlockControls()
	SysCall ( "ScenarioManager:UnlockControls");
end

function WatchForStopAt( location, msg_event, change_event, actionEvent )
	gStopLocation = location
	gStopMessageEvent = msg_event
	gStopChangeEvent = change_event
	gStopActionEvent = actionEvent
end

function ClearStopAt()
	gStopLocation = ""
	gStopMessageEvent = ""
	gStopChangeEvent = ""
	gStopActionEvent = ""
end

function WatchForStartAt( location, event )
	gStartLocation = location
	gStartEvent = event
end

function ClearStartAt()
	gStartLocation = ""
	gStartEvent = ""
end

function OnEventDetailedOn()
	gDetailed = "Yes"
end

function OnEventDetailedOff()
	gDetailed = "No"
end

function OnEventintroText1()
	DisplayRecordedMessage ("IntroText1");
end

function OnEventchangeCab()
	DisplayRecordedMessage ("ChangeCab" .. string.sub(gStopMessageEvent,10,13));
	Cab()
end

function OnEventpowerChangeDown()	
	DisplayRecordedMessage ("ChangeoverDown");
	--DeferredEvent("Lookat", 9)
end

function OnEventpowerChangeUp()	
	DisplayRecordedMessage ("ChangeoverUp");
end

function OnEventDepartCLJ()
	DisplayRecordedMessage ("DepartCLJ");
end

function OnEventDepartWJH()
	DisplayRecordedMessage ("DepartWJH");
end

function OnEventGuard()
	DisplayRecordedMessage ("Guard");
end

function OnEventSignaller()
	DisplayRecordedMessage ("Signaller");
end

function GetRVNum()
	gVehicleNum = SysCall ( "PlayerEngine:GetRVNumber" )
end

function OnEventChangeRV_NIS()
	SetDestination(NIS);
end

function OnEventChangeRV_CLJ()
	SetDestination(CLJ);
end 

function OnEventDoors()
	DoorsOpenClose();
end

function OnEventUnhide()
	for i = 10, 11, 1 do
		ScenarioManager:UnhideDriverInstruction (i);
	end
end

function OnEventMenu()
	SysCall ("ScenarioManager:ShowAlertMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "Yes I would like detailed instructions before every power change!  (Default)", 15, "DetailedOn" );
	SysCall ("ScenarioManager:ShowAlertMessageExt", "4e082f8e-538d-4b5a-a970-180f9af07d27", "No thanks I know what I am doing!", 15, "DetailedOff" );
end

function OnEventStart()
	GetRVNum();
	LockControls();
	PlayCamera("introCamera");
	DeferredEvent("introText1", 2);
	DeferredEvent("Headlights", 1);
	DeferredEvent("CabCamera", 15);
end

function OnEventCabCamera()
	UnlockControls();
	PlayCamera("CabCamera");
	DisplayRecordedMessage ("IntroText2");
	OnEvent("Menu");
end

function OnEventHeadlights()
	SysCall("PlayerEngine:SetControlValue", "Headlights", 0, 3);
	SysCall("PlayerEngine:SetControlValue", "CabLight", 0, 0);
end

function OnEventchangeCabend()
	UnlockControls();
	PlayCamera("CabCamera");
end	
	
function OnEventLookat()
	SysCall ("ScenarioManager:LookAtControl", "PanDown", 2.0, 5.0, 0.5);
	DeferredEvent("Reset", 5);
end

function OnEventReset()
	SysCall ("ScenarioManager:RestoreCameraToDefault", 2);
end

function OnEventStopped_Turnback()
	WatchForStopAt("Kensal Green Turnback", "changeCab_XKG", "", "Msg");
end

function OnEventStopped_CLJ()
	WatchForStopAt("Clapham Junction Platform 01", "introText1", "ChangeRV_NIS", "Change");
end

function OnEventMoving_SPB()
	WatchForStartAt("Shepherd's Bush Platform 2", "powerChangeDown");
	WatchForStopAt("Willesden Junction Platform 4", "DepartWJH", "", "Msg");
end

function OnEventMoving_WJH()
	SysCall ("ScenarioManager:BeginConditionCheck", "Stopped");
	if ( gDetailed == "Yes") then
		SysCall ("ScenarioManager:BeginConditionCheck", "Moving");
	end
	WatchForStartAt("Willesden Junction Platform 5", "powerChangeUp");
	WatchForStopAt("Clapham Junction Platform 01", "changeCab_CLJ", "ChangeRV_NIS", "Both");
end

function OnEventchangeCabstart_CLJ()
	LockControls();
	PlayCamera("changeCab_CLJ");
	DeferredEvent("changeCabend", 40);
	DeferredEvent("DepartCLJ", 41);
	ResetTrain();
end

function OnEventchangeCabstart_XKG()
	LockControls();
	DistanceToEnd();
	DeferredEvent("changeCabend", 30);
	ResetTrain();
end

function Cab()
	SysCall ("ScenarioManager:BeginConditionCheck", "Cab" .. string.sub(gStopMessageEvent,10,13));
end

function DistanceToEnd()
	local result, state, distance, proState = SysCall( "PlayerEngine:GetNextRestrictiveSignal", 1 );
	if (distance <= 90) then
		PlayCamera("changeCab_XKG1");
	elseif (distance <=110) then
		PlayCamera("changeCab_XKG2");
	elseif (distance <= 130) then
		PlayCamera("changeCab_XKG3");
	elseif (distance <= 150) then
		PlayCamera("changeCab_XKG4");
	elseif (distance <= 170) then
		PlayCamera("changeCab_XKG5");
	elseif (distance <= 190) then
		PlayCamera("changeCab_XKG6");
	elseif (distance <= 210) then
		PlayCamera("changeCab_XKG7");
	elseif (distance <= 230) then
		PlayCamera("changeCab_XKG8");
	else
		PlayCamera("changeCab_XKG9");
	end
end

function ResetTrain()
	SysCall("PlayerEngine:SetControlValue", "Headlights", 0, 1);
	SysCall(gVehicleNum .. ":SetControlValue", "AWS", 0, 0);
	SysCall(gVehicleNum .. ":SetControlValue", "AWSClearCount", 0, 0);
	SysCall(gVehicleNum .. ":SetControlValue", "AWSReady", 0, 1);
end

function DoorsOpenClose()
	dest = string.sub(gVehicleNum, 1, 1);
	train = string.sub(gVehicleNum, 11, 12);
	unit = string.sub(gVehicleNum, 7, 12);
	openclose = SysCall ("PlayerEngine:GetControlValue", "DoorsOpenCloseRight", 0)
	if (openclose == 0) then
		openclose = 1
	else
		openclose = 0
	end
	for i = 0, 4, 1 do
		if (i == 0) then
			SysCall (dest .. "38" .. i .. train .. unit .. ":SetControlValue", "DoorsOpenCloseRight", 0, openclose);
		elseif (i == 1) then
			SysCall (dest .. "38" .. i .. train .. unit .. ":SetControlValue", "DoorsOpenCloseLeft", 0, openclose);
		else
			SysCall (dest .. "38" .. i .. train .. ":SetControlValue", "DoorsOpenCloseRight", 0, openclose);
		end
	end
end

function SetDestination(NewDestination)
	local Destination = string.sub(gVehicleNum, 1, 1);
	local TrainNum = string.sub(gVehicleNum, 11, 12);
	local UnitNum = string.sub(gVehicleNum, 7, 12);
	for i = 0, 4, 1 do
		if (i <= 1) then
			SysCall (Destination .. "38" .. i .. TrainNum .. UnitNum .. ":SetRVNumber", NewDestination .. "38" .. i .. TrainNum .. UnitNum);
		else
			SysCall (Destination .. "38" .. i .. TrainNum .. ":SetRVNumber", NewDestination .. "38" .. i .. TrainNum);
		end
	end
end

function TestConditionMoving()
    speed = SysCall ( "PlayerEngine:GetSpeed" ) * gSpeedUnits;
	serviceAtOrigin = SysCall("ScenarioManager:IsAtDestination", gStopPlayerServiceName, gStartLocation);
    if (speed > 5) and (serviceAtOrigin == 1) then
		OnEvent(gStartEvent);
		local startEvent = gStartEvent
		ClearStartAt();
			if (StartEvent == "powerChangeUp") then
				return CONDITION_SUCCEEDED;
			end
	end
    return CONDITION_NOT_YET_MET;
end
  
function TestConditionStopped()
    speed = SysCall ( "PlayerEngine:GetSpeed" ) * gSpeedUnits;
	serviceAtDestination = SysCall("ScenarioManager:IsAtDestination", gStopPlayerServiceName, gStopLocation);
	if (speed <= 0.01) and (serviceAtDestination == 1) then
		if (gStopActionEvent == "Both") or (gStopActionEvent == "Msg") then
			OnEvent(string.sub(gStopMessageEvent,1,9));
		end
		ClearStopAt();
		StopFlag = 0;
	elseif (StopFlag == 0) and (serviceAtDestination == 1) then
		if (gStopActionEvent == "Both") or  (gStopActionEvent == "Change") then
			OnEvent(gStopChangeEvent);
		end
		StopFlag = 1;
	end
	return CONDITION_NOT_YET_MET;
end

function TestConditionCab_CLJ()
    speed = SysCall ( "PlayerEngine:GetSpeed" ) * gSpeedUnits;
	aws = SysCall("PlayerEngine:GetControlValue", "AWSReady", 0);
	if (speed <= 0.1) and (aws == 1) then
		OnEvent("changeCabstart_CLJ");
		return CONDITION_SUCCEEDED;
	end
	return CONDITION_NOT_YET_MET;
 end
 
 function TestConditionCab_XKG()
    speed = SysCall ( "PlayerEngine:GetSpeed" ) * gSpeedUnits;
	aws = SysCall("PlayerEngine:GetControlValue", "AWSReady", 0);
	if (speed <= 0.1) and (aws == 1) then
		OnEvent("changeCabstart_XKG");
		return CONDITION_SUCCEEDED;
	end
	return CONDITION_NOT_YET_MET;
 end
 
 function TestConditionWaiting()
    ScenarioTime = SysCall("ScenarioManager:GetScenarioTime")
    if (ScenarioTime >= 2850) then
		return CONDITION_SUCCEEDED;
	end
    return CONDITION_NOT_YET_MET;
end